searchNodes=[{"ref":"MapBot.html","title":"MapBot","module":"MapBot","type":"module","doc":"Elixir.MapBot builds Elixir Maps/Structs based on factory definitions and attributes. Let&#39;s see how to use this library by examples: Examples setup: defmodule MyApp.Car do @moduledoc false defstruct id: nil, color: nil, model: nil end defmodule MyApp.House do @moduledoc false defstruct id: nil, color: nil, style: nil def changeset(%__MODULE__{} = schema, attrs) do Map.merge(schema, attrs) end end defmodule MyApp.Repo do @moduledoc false def insert(schema), do: {:ok, schema} def insert!(schema), do: schema end defmodule MyApp.FactoryWithNoRepo do @moduledoc false use MapBot deffactory(MyApp.Car) do %MyApp.Car{ id: &amp; &amp;1, color: color(), model: ~w(Truck SUV Hatch) |&gt; Enum.random() } end deffactory(:tomato) do %{ name: &amp;&quot;Tomato-\#{&amp;1}&quot;, color: color() } end defp color(), do: ~w(red white black blue green)a |&gt; Enum.random() end defmodule MyApp.FactoryWithRepo do @moduledoc false use MapBot, repo: MyApp.Repo deffactory(MyApp.Car) do %MyApp.Car{ id: &amp; &amp;1, color: color(), model: ~w(Truck SUV Hatch) |&gt; Enum.random() } end defp color(), do: ~w(red white black blue green)a |&gt; Enum.random() end defmodule MyApp.FactoryWithRepoAndChangeset do @moduledoc false use MapBot, repo: MyApp.Repo, changeset: true deffactory(MyApp.House) do %MyApp.House{ id: &amp; &amp;1, color: color(), style: ~w(Asian Mediterranean Colonial American Modern) |&gt; Enum.random() } end defp color(), do: ~w(red white black blue green)a |&gt; Enum.random() end Examples attrs/2: iex&gt; Elixir.MapBot.Sequence.reset(5) iex&gt; :rand.seed(:exsplus, {1, 2, 3}) ...&gt; iex&gt; MyApp.FactoryWithNoRepo.attrs(MyApp.Car) %{id: 5, model: &quot;Truck&quot;, color: :green} ...&gt; iex&gt; MyApp.FactoryWithNoRepo.attrs(MyApp.Car, color: :yellow) %{id: 6, model: &quot;Hatch&quot;, color: :yellow} ...&gt; iex&gt; MyApp.FactoryWithNoRepo.attrs(MyApp.Car, %{color: :purple}) %{id: 7, model: &quot;Hatch&quot;, color: :purple} ...&gt; iex&gt; MyApp.FactoryWithNoRepo.attrs(:tomato) %{name: &quot;Tomato-8&quot;, color: :blue} ...&gt; iex&gt; MyApp.FactoryWithNoRepo.attrs(:tomato, color: :white) %{name: &quot;Tomato-9&quot;, color: :white} ...&gt; iex&gt; MyApp.FactoryWithNoRepo.attrs(:tomato, %{color: :pink}) %{name: &quot;Tomato-10&quot;, color: :pink} build/2: iex&gt; Elixir.MapBot.Sequence.reset(5) iex&gt; :rand.seed(:exsplus, {1, 2, 3}) ...&gt; iex&gt; MyApp.FactoryWithNoRepo.build(MyApp.Car) %MyApp.Car{id: 5, model: &quot;Truck&quot;, color: :green} ...&gt; iex&gt; MyApp.FactoryWithNoRepo.build(MyApp.Car, color: :yellow) %MyApp.Car{id: 6, model: &quot;Hatch&quot;, color: :yellow} ...&gt; iex&gt; MyApp.FactoryWithNoRepo.build(MyApp.Car, %{color: :purple}) %MyApp.Car{id: 7, model: &quot;Hatch&quot;, color: :purple} ...&gt; iex&gt; MyApp.FactoryWithNoRepo.build(:tomato) %{name: &quot;Tomato-8&quot;, color: :blue} ...&gt; iex&gt; MyApp.FactoryWithNoRepo.build(:tomato, color: :white) %{name: &quot;Tomato-9&quot;, color: :white} ...&gt; iex&gt; MyApp.FactoryWithNoRepo.build(:tomato, %{color: :pink}) %{name: &quot;Tomato-10&quot;, color: :pink} insert/2: iex&gt; Elixir.MapBot.Sequence.reset(5) iex&gt; :rand.seed(:exsplus, {1, 2, 3}) ...&gt; iex&gt; MyApp.FactoryWithRepo.insert(MyApp.Car) {:ok, %MyApp.Car{id: 5, model: &quot;Truck&quot;, color: :green}} ...&gt; iex&gt; MyApp.FactoryWithRepo.insert(MyApp.Car, color: :yellow) {:ok, %MyApp.Car{id: 6, model: &quot;Hatch&quot;, color: :yellow}} ...&gt; iex&gt; MyApp.FactoryWithRepo.insert(MyApp.Car, %{color: :purple}) {:ok, %MyApp.Car{id: 7, model: &quot;Hatch&quot;, color: :purple}} ...&gt; iex&gt; MyApp.FactoryWithRepoAndChangeset.insert(MyApp.House) {:ok, %MyApp.House{id: 8, style: &quot;Asian&quot;, color: :blue}} ...&gt; iex&gt; MyApp.FactoryWithRepoAndChangeset.insert(MyApp.House, color: :yellow) {:ok, %MyApp.House{id: 9, style: &quot;Asian&quot;, color: :yellow}} ...&gt; iex&gt; MyApp.FactoryWithRepoAndChangeset.insert(MyApp.House, %{color: :purple}) {:ok, %MyApp.House{id: 10, style: &quot;American&quot;, color: :purple}} insert!/2: iex&gt; Elixir.MapBot.Sequence.reset(5) iex&gt; :rand.seed(:exsplus, {1, 2, 3}) ...&gt; iex&gt; MyApp.FactoryWithRepo.insert!(MyApp.Car) %MyApp.Car{id: 5, model: &quot;Truck&quot;, color: :green} ...&gt; iex&gt; MyApp.FactoryWithRepo.insert!(MyApp.Car, color: :yellow) %MyApp.Car{id: 6, model: &quot;Hatch&quot;, color: :yellow} ...&gt; iex&gt; MyApp.FactoryWithRepo.insert!(MyApp.Car, %{color: :purple}) %MyApp.Car{id: 7, model: &quot;Hatch&quot;, color: :purple} ...&gt; iex&gt; MyApp.FactoryWithRepoAndChangeset.insert!(MyApp.House) %MyApp.House{id: 8, style: &quot;Asian&quot;, color: :blue} ...&gt; iex&gt; MyApp.FactoryWithRepoAndChangeset.insert!(MyApp.House, color: :yellow) %MyApp.House{id: 9, style: &quot;Asian&quot;, color: :yellow} ...&gt; iex&gt; MyApp.FactoryWithRepoAndChangeset.insert!(MyApp.House, %{color: :purple}) %MyApp.House{id: 10, style: &quot;American&quot;, color: :purple}"},{"ref":"MapBot.html#__using__/1","title":"MapBot.__using__/1","module":"MapBot","type":"macro","doc":"Use __MODULE__ with the following options: :repo =&gt; Repository module to delegate calls on insert/1 and insert!/1 :changeset =&gt; If true a changeset/2 function will be called when inserting into the Repo Examples iex&gt; MyApp.FactoryWithNoRepo.__info__(:functions) [attrs: 1, attrs: 2, build: 1, build: 2] iex&gt; MyApp.FactoryWithRepo.__info__(:functions) [attrs: 1, attrs: 2, build: 1, build: 2, insert: 1, insert: 2, insert!: 1, insert!: 2] iex&gt; MyApp.FactoryWithRepoAndChangeset.__info__(:functions) [attrs: 1, attrs: 2, build: 1, build: 2, insert: 1, insert: 2, insert!: 1, insert!: 2, validate: 2]"},{"ref":"MapBot.html#deffactory/2","title":"MapBot.deffactory/2","module":"MapBot","type":"macro","doc":"Macro that defines a factory for the name argument."},{"ref":"MapBot.html#t:name/0","title":"MapBot.name/0","module":"MapBot","type":"type","doc":""},{"ref":"MapBot.html#t:use_option/0","title":"MapBot.use_option/0","module":"MapBot","type":"type","doc":""},{"ref":"readme.html","title":"MapBot","module":"readme","type":"extras","doc":"MapBot MapBot builds Elixir Maps/Structs based on factory definitions and attributes. Note that this library is very flexible and also very light. It does not add any dependency in your application. In other words it does not add any third party code such Ecto or Faker but it is so flexible that you can use them if you want to as factory definition remains if your application."},{"ref":"readme.html#factories-definition","title":"MapBot - Factories Definition:","module":"readme","type":"extras","doc":"Factories are defined in a single module in your application such as: defmodule MyApp.Factory do @moduledoc false use MapBot, repo: MyApp.Repo, changeset: true deffactory(MyApp.Car) do %MyApp.Car{ id: &amp; &amp;1, color: color(), model: ~w(Truck SUV Hatch) |&gt; Enum.random() } end deffactory(:tomato) do %{ name: &amp;&quot;Tomato-\#{&amp;1}&quot;, color: color() } end defp color(), do: ~w(red white black blue green)a |&gt; Enum.random() end"},{"ref":"readme.html#examples","title":"MapBot - Examples","module":"readme","type":"extras","doc":"attrs/2: iex&gt; MyApp.Factory.attrs(MyApp.Car) %{id: 5, model: &quot;Truck&quot;, color: :green} iex&gt; MyApp.Factory.attrs(MyApp.Car, color: :yellow) %{id: 6, model: &quot;Hatch&quot;, color: :yellow} iex&gt; MyApp.Factory.attrs(MyApp.Car, %{color: :purple}) %{id: 7, model: &quot;Hatch&quot;, color: :purple} iex&gt; MyApp.Factory.attrs(:tomato) %{name: &quot;Tomato-8&quot;, color: :blue} iex&gt; MyApp.Factory.attrs(:tomato, color: :white) %{name: &quot;Tomato-9&quot;, color: :white} iex&gt; MyApp.Factory.attrs(:tomato, %{color: :pink}) %{name: &quot;Tomato-10&quot;, color: :pink} build/2: iex&gt; MyApp.Factory.build(MyApp.Car) %MyApp.Car{id: 5, model: &quot;Truck&quot;, color: :green} iex&gt; MyApp.Factory.build(MyApp.Car, color: :yellow) %MyApp.Car{id: 6, model: &quot;Hatch&quot;, color: :yellow} iex&gt; MyApp.Factory.build(MyApp.Car, %{color: :purple}) %MyApp.Car{id: 7, model: &quot;Hatch&quot;, color: :purple} iex&gt; MyApp.Factory.build(:tomato) %{name: &quot;Tomato-8&quot;, color: :blue} iex&gt; MyApp.Factory.build(:tomato, color: :white) %{name: &quot;Tomato-9&quot;, color: :white} iex&gt; MyApp.Factory.build(:tomato, %{color: :pink}) %{name: &quot;Tomato-10&quot;, color: :pink} insert/2: iex&gt; MyApp.Factory.insert(MyApp.Car) {:ok, %MyApp.Car{id: 5, model: &quot;Truck&quot;, color: :green}} iex&gt; MyApp.Factory.insert(MyApp.Car, color: :yellow) {:ok, %MyApp.Car{id: 6, model: &quot;Hatch&quot;, color: :yellow}} iex&gt; MyApp.Factory.insert(MyApp.Car, %{color: :purple}) {:ok, %MyApp.Car{id: 7, model: &quot;Hatch&quot;, color: :purple}} insert!/2: iex&gt; MyApp.Factory.insert!(MyApp.Car) %MyApp.Car{id: 5, model: &quot;Truck&quot;, color: :green} iex&gt; MyApp.Factory.insert!(MyApp.Car, color: :yellow) %MyApp.Car{id: 6, model: &quot;Hatch&quot;, color: :yellow} iex&gt; MyApp.Factory.insert!(MyApp.Car, %{color: :purple}) %MyApp.Car{id: 7, model: &quot;Hatch&quot;, color: :purple}"},{"ref":"readme.html#documentation","title":"MapBot - Documentation","module":"readme","type":"extras","doc":"There&#39;s much more use cases on the hexdocs/map_bot documentation."},{"ref":"readme.html#installation","title":"MapBot - Installation","module":"readme","type":"extras","doc":"Check out map_bot version on hex.pm/map_bot. The package can be installed by adding map_bot to your list of dependencies in mix.exs: def deps do [ {:map_bot, &quot;~&gt; 1.3.0&quot;} ] end If you are going to use MapBot.Sequence please start the counter by adding into your test/test_helper.exs the following: # test/test_helper.exs {:ok, _pid} = MapBot.Sequence.start_link()"},{"ref":"readme.html#development","title":"MapBot - Development","module":"readme","type":"extras","doc":"Check out the Makefile for useful development tasks."}]